<template>
  <tr class="tbody-style">
    <td>{{ticket.ticketId}}</td>
    <td>{{truncate(ticket.title, 10)}}</td>
    <td>{{ truncate(ticket.description, 10) }}</td>
    <td>{{ticket.createdAt}}</td>
    <!--    <td>{{ticket.priority}}</td>-->
    <td v-if="ticket.priority === 'VERY_IMPORTANT'"><v-icon color="deep-orange-darken-4">mdi-alpha-a-circle-outline</v-icon></td>
    <td v-if="ticket.priority === 'IMPORTANT'"><v-icon color="deep-orange-darken-3">mdi-alpha-b-circle-outline</v-icon></td>
    <td v-if="ticket.priority === 'MODERATE'"><v-icon color="deep-orange-darken-2">mdi-alpha-c-circle-outline</v-icon></td>
    <td v-if="ticket.priority === 'LESS_IMPORTANT'"><v-icon color="deep-orange-darken-2">mdi-alpha-d-circle-outline</v-icon></td>
    <!--    <td>{{ticket.ticketStatus}}</td>-->
    <td v-if="ticket.ticketStatus === 'OPEN'"><v-icon color="green-darken-3">mdi-circle</v-icon></td>
    <td v-if="ticket.ticketStatus === 'PENDING'"><v-icon color="yellow-darken-3">mdi-octagon</v-icon></td>
    <td v-if="ticket.ticketStatus === 'PROBLEM'"><v-icon color="red-accent-4">mdi-alert</v-icon></td>
    <td v-if="ticket.ticketStatus === 'RESOLVED'"><v-icon color="blue-darken-4">mdi-check-circle</v-icon></td>
    <td>{{ticket.department}}</td>
    <td><v-btn
        size="small"
        v-show="ticket.department === authStore.user.department && authStore.user.role !== 'ADMIN'"
        :disabled="ticket.ticketStatus === 'PENDING'"
        @click.stop="acceptTicket" v-if="ticket.ticketStatus !== 'RESOLVED'"
        color="green-darken-3"><v-icon>mdi-check</v-icon></v-btn>
      <v-btn
          size="small"
          v-show="authStore.user.role === 'ADMIN'"
          :disabled="ticket.ticketStatus === 'PENDING'"
          @click.stop="acceptTicket" v-if="ticket.ticketStatus !== 'RESOLVED'"
          color="green-darken-3"><v-icon>mdi-check</v-icon></v-btn>
      <v-btn
          class="me-1 ms-1"
          size="small"
          v-if="authStore.user.role === 'ADMIN'"
          color="red-accent-4"
          @click="deleteTicket"
      ><v-icon>mdi-delete</v-icon></v-btn>
      <v-btn
          class="me-1 ms-1"
          size="small"
          v-if="authStore.user.role === 'MANAGER' && ticket.department === authStore.user.department"
          color="red-accent-4"
          @click="deleteTicket"
      ><v-icon>mdi-delete</v-icon></v-btn>
      <v-btn
          size="small"
          color="blue-darken-4"
          @click="showDetails"><v-icon>mdi-information-outline</v-icon></v-btn></td>
  </tr>

<!--  DIALOG-->
  <v-dialog v-model="dialog">
    <v-card class="align-center">
      <v-card-title>
        Löschen
      </v-card-title>
      <v-card-text>
        Bist du sicher, dass du das Ticket "{{ ticket.ticketId }} {{ ticket.title }}" löschen willst?
      </v-card-text>
      <v-card-actions>
        <v-btn color="green-darken-3" text @click="confirmDelete">Ja</v-btn>
        <v-btn color="red-accent-4" text @click="dialog = false">Abbrechen</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup>
import {useAuthStore} from "@/stores/authStore";
import {useUserStore} from "@/stores/userStore";
import {ref} from "vue";
import {useTicketStore} from "@/stores/ticketStore";
import {router} from "@/router";

//STORES
const authStore = useAuthStore();
const userStore =useUserStore();
const ticketStore = useTicketStore();

//PROPS & EMITS
const props = defineProps(['ticket', 'page']);
const emits = defineEmits(['showComponent']);

//VARIABLES
let dialog = ref(false);
const ticketAccepted = ref({
  ticketStatus: "PENDING",
  userId: authStore.user.userId
});

//FUNCTIONS
async function deleteTicket() {
  dialog.value = true;
}

async function confirmDelete() {
  try {
    // Close the dialog
    dialog.value = false;

    // Perform deletion
    await ticketStore.deleteTicket(props.ticket.ticketId);
    await ticketStore.getTickets(props.page)
  } catch (error) {
    alert("Du kannst das Ticket nicht löschen!");
    console.log(error)
  }
}
async function navigateToSingleTicket() {
  try {
    await router.push({ name: "SingleTicketData", params: { id: props.ticket.ticketId } });
  } catch (error) {
    console.log("Error: ", error);
    alert("Etwas ist schief gelaufen.")
  }
}

async function showDetails() {
  try {
    await router.push({ name: "SingleTicketView", params: { id: props.ticket.ticketId } });
  } catch (error) {
    console.log("Error: ", error)
    alert("Etwas ist schief gelaufen.")
  }
}

async function acceptTicket() {
  try {
    await ticketStore.acceptTicket(props.ticket.ticketId, ticketAccepted.value)
    await router.push({ name: "SingleTicketView", params: { id: props.ticket.ticketId } });
  } catch (error) {
    console.log("error", error);
    alert("Etwas ist schief gelaufen.")
  }
}

const truncate = (text, maxLength) => {
  if (text.length <= maxLength) {
    return text;
  } else {
    return text.slice(0, maxLength) + '...';
  }
};
</script>

<style scoped>


</style>